;
; ntfsinfo.ahk
;   Script to show hardlink count, creation time, and access time in Afx status bar
;   Written by Yak!
;
;   $URL: https://yak.myhome.cx/repos/source/afxscrpt/trunk/ntfsinfo.ahk $
;   $Date: 2007-06-13 01:15:05 +0900 (Wed, 13 Jun 2007) $
;   $Rev: 391 $
;

#NoTrayIcon

DELETE=0x00010000L
READ_CONTROL=0x20000L
WRITE_DAC=0x40000L
WRITE_OWNER=0x80000L
SYNCHRONIZE=0x100000L
STANDARD_RIGHTS_REQUIRED=0xF0000
STANDARD_RIGHTS_READ=0x20000
STANDARD_RIGHTS_WRITE=0x20000
STANDARD_RIGHTS_EXECUTE=0x20000
STANDARD_RIGHTS_ALL=0x1F0000
SPECIFIC_RIGHTS_ALL=0xFFFF
ACCESS_SYSTEM_SECURITY=0x1000000
MAXIMUM_ALLOWED=0x2000000
GENERIC_READ=0x80000000
GENERIC_WRITE=0x40000000
GENERIC_EXECUTE=0x20000000
GENERIC_ALL=0x10000000
FILE_LIST_DIRECTORY=0x00000001
FILE_READ_DATA=0x00000001
FILE_ADD_FILE=0x00000002
FILE_WRITE_DATA=0x00000002
FILE_ADD_SUBDIRECTORY=0x00000004
FILE_APPEND_DATA=0x00000004
FILE_CREATE_PIPE_INSTANCE=0x00000004
FILE_READ_EA=0x00000008
FILE_READ_PROPERTIES=0x00000008
FILE_WRITE_EA=0x00000010
FILE_WRITE_PROPERTIES=0x00000010
FILE_EXECUTE=0x00000020
FILE_TRAVERSE=0x00000020
FILE_DELETE_CHILD=0x00000040
FILE_READ_ATTRIBUTES=0x00000080
FILE_WRITE_ATTRIBUTES=0x00000100
FILE_ALL_ACCESS=2032127
FILE_GENERIC_EXECUTE=1179808
FILE_GENERIC_READ=1179785
FILE_GENERIC_WRITE=1179926

FILE_SHARE_DELETE=4
FILE_SHARE_READ=1
FILE_SHARE_WRITE=2

CREATE_ALWAYS=2
CREATE_NEW=1
OPEN_ALWAYS=4
OPEN_EXISTING=3
TRUNCATE_EXISTING=5

FILE_ATTRIBUTE_ARCHIVE=32
FILE_ATTRIBUTE_ENCRYPTED=16384
FILE_ATTRIBUTE_HIDDEN=2
FILE_ATTRIBUTE_NORMAL=128
FILE_ATTRIBUTE_NOT_CONTENT_INDEXED=8192
FILE_ATTRIBUTE_OFFLINE=4096
FILE_ATTRIBUTE_READONLY=1
FILE_ATTRIBUTE_SYSTEM=4
FILE_ATTRIBUTE_TEMPORARY=256

FILE_FLAG_WRITE_THROUGH=0x80000000
FILE_FLAG_OVERLAPPED=1073741824
FILE_FLAG_NO_BUFFERING=536870912
FILE_FLAG_RANDOM_ACCESS=268435456
FILE_FLAG_SEQUENTIAL_SCAN=134217728
FILE_FLAG_DELETE_ON_CLOSE=67108864
FILE_FLAG_BACKUP_SEMANTICS=33554432
FILE_FLAG_POSIX_SEMANTICS=16777216
FILE_FLAG_OPEN_REPARSE_POINT=2097152
FILE_FLAG_OPEN_NO_RECALL=1048576
FILE_FLAG_FIRST_PIPE_INSTANCE=524288

SECURITY_ANONYMOUS=0
SECURITY_IDENTIFICATION=65536
SECURITY_IMPERSONATION=131072
SECURITY_DELEGATION=196608
SECURITY_CONTEXT_TRACKING=262144
SECURITY_EFFECTIVE_ONLY=524288
SECURITY_SQOS_PRESENT=1048576
SECURITY_VALID_SQOS_FLAGS=2031616

ExtractInteger(ByRef pSource, pOffset = 0, pIsSigned = false, pSize = 4)
; pSource is a string (buffer) whose memory area contains a raw/binary integer at pOffset.
; The caller should pass true for pSigned to interpret the result as signed vs. unsigned.
; pSize is the size of PSource's integer in bytes (e.g. 4 bytes for a DWORD or Int).
; pSource must be ByRef to avoid corruption during the formal-to-actual copying process
; (since pSource might contain valid data beyond its first binary zero).
{
    Loop %pSize%  ; Build the integer by adding up its bytes.
        result += *(&pSource + pOffset + A_Index-1) << 8*(A_Index-1)
    if (!pIsSigned OR pSize > 4 OR result < 0x80000000)
        return result  ; Signed vs. unsigned doesn't matter in these cases.
    ; Otherwise, convert the value (now known to be 32-bit) to its signed counterpart:
    return -(0xFFFFFFFF - result + 1)
}

InsertInteger(pInteger, ByRef pDest, pOffset = 0, pSize = 4)
; The caller must ensure that pDest has sufficient capacity.  To preserve any existing contents in pDest,
; only pSize number of bytes starting at pOffset are altered in it.
{
    Loop %pSize%  ; Copy each byte in the integer into the structure as raw binary data.
        DllCall("RtlFillMemory", "UInt", &pDest + pOffset + A_Index-1, "UInt", 1, "UChar", pInteger >> 8*(A_Index-1) & 0xFF)
}
CopyMemory(dest, source, size)
{
    Loop, %size%
        DllCall("RtlFillMemory", "UInt", dest + A_Index-1, "UInt", 1, "UChar", *(source + A_Index-1) & 0xFF)
}


Init_FT(ByRef source)
{
    VarSetCapacity(source, 8, 0)
}
Get_FT_dwLowDateTime(ByRef source)
{
    return ExtractInteger(source, 0, false, 4)
}
Set_FT_dwLowDateTime(ByRef source, content)
{
    InsertInteger(content, source, 0, 4)
}
Get_FT_dwHighDateTime(ByRef source)
{
    return ExtractInteger(source, 4, false, 4)
}
Set_FT_dwHighDateTime(ByRef source, content)
{
    InsertInteger(content, source, 4, 4)
}

Init_BHFI(ByRef source)
{
    VarSetCapacity(source, 52, 0)
}
Get_BHFI_dwFileAttributes(ByRef source)
{
    return ExtractInteger(source, 0, false, 4)
}
Set_BHFI_dwFileAttributes(ByRef source, content)
{
    InsertInteger(content, source, 0, 4)
}
Get_BHFI_ftCreationTime(ByRef source, ByRef dest)
{
    CopyMemory(&dest, &source + 4, 8)
}
Set_BHFI_ftCreationTime(ByRef source, ByRef content)
{
    CopyMemory(&source + 4, &content, 8)
}
Get_BHFI_ftLastAccessTime(ByRef source, ByRef dest)
{
    CopyMemory(&dest, &source + 12, 8)
}
Set_BHFI_ftLastAccessTime(ByRef source, ByRef content)
{
    CopyMemory(&source + 12, &content, 8)
}
Get_BHFI_ftLastWriteTime(ByRef source, ByRef dest)
{
    CopyMemory(&dest, &source + 20, 8)
}
Set_BHFI_ftLastWriteTime(ByRef source, ByRef content)
{
    CopyMemory(&source + 20, &content, 8)
}
Get_BHFI_dwVolumeSerialNumber(ByRef source)
{
    return ExtractInteger(source, 28, false, 4)
}
Set_BHFI_dwVolumeSerialNumber(ByRef source, content)
{
    InsertInteger(content, source, 28, 4)
}
Get_BHFI_nFileSizeHigh(ByRef source)
{
    return ExtractInteger(source, 32, false, 4)
}
Set_BHFI_nFileSizeHigh(ByRef source, content)
{
    InsertInteger(content, source, 32, 4)
}
Get_BHFI_nFileSizeLow(ByRef source)
{
    return ExtractInteger(source, 36, false, 4)
}
Set_BHFI_nFileSizeLow(ByRef source, content)
{
    InsertInteger(content, source, 36, 4)
}
Get_BHFI_nNumberOfLinks(ByRef source)
{
    return ExtractInteger(source, 40, false, 4)
}
Set_BHFI_nNumberOfLinks(ByRef source, content)
{
    InsertInteger(content, source, 40, 4)
}
Get_BHFI_nFileIndexHigh(ByRef source)
{
    return ExtractInteger(source, 44, false, 4)
}
Set_BHFI_nFileIndexHigh(ByRef source, content)
{
    InsertInteger(content, source, 44, 4)
}
Get_BHFI_nFileIndexLow(ByRef source)
{
    return ExtractInteger(source, 48, false, 4)
}
Set_BHFI_nFileIndexLow(ByRef source, content)
{
    InsertInteger(content, source, 48, 4)
}

Init_ST(ByRef source)
{
    VarSetCapacity(source, 16, 0)
}
Get_ST_wYear(ByRef source)
{
    return ExtractInteger(source, 0, false, 2)
}
Set_ST_wYear(ByRef source, content)
{
    InsertInteger(content, source, 0, 2)
}
Get_ST_wMonth(ByRef source)
{
    return ExtractInteger(source, 2, false, 2)
}
Set_ST_wMonth(ByRef source, content)
{
    InsertInteger(content, source, 2, 2)
}
Get_ST_wDayOfWeek(ByRef source)
{
    return ExtractInteger(source, 4, false, 2)
}
Set_ST_wDayOfWeek(ByRef source, content)
{
    InsertInteger(content, source, 4, 2)
}
Get_ST_wDay(ByRef source)
{
    return ExtractInteger(source, 6, false, 2)
}
Set_ST_wDay(ByRef source, content)
{
    InsertInteger(content, source, 6, 2)
}
Get_ST_wHour(ByRef source)
{
    return ExtractInteger(source, 8, false, 2)
}
Set_ST_wHour(ByRef source, content)
{
    InsertInteger(content, source, 8, 2)
}
Get_ST_wMinute(ByRef source)
{
    return ExtractInteger(source, 10, false, 2)
}
Set_ST_wMinute(ByRef source, content)
{
    InsertInteger(content, source, 10, 2)
}
Get_ST_wSecond(ByRef source)
{
    return ExtractInteger(source, 12, false, 2)
}
Set_ST_wSecond(ByRef source, content)
{
    InsertInteger(content, source, 12, 2)
}
Get_ST_wMilliseconds(ByRef source)
{
    return ExtractInteger(source, 14, false, 2)
}
Set_ST_wMilliseconds(ByRef source, content)
{
    InsertInteger(content, source, 14, 2)
}


GetFileInformationByHandle(arg1, arg2)
{
	return DllCall("GetFileInformationByHandle", "UInt", arg1, "UInt", arg2)
}
CreateFile(arg1, arg2, arg3, arg4, arg5, arg6, arg7)
{
	return DllCall("CreateFile", "Str", arg1, "UInt", arg2, "UInt", arg3, "UInt", arg4, "UInt", arg5, "UInt", arg6, "UInt", arg7, "UInt")
}
;defined in win32.ahk included by afxctrl.ahk
;CloseHandle(arg1)
;{
;	return DllCall("CloseHandle", "UInt", arg1)
;}

FileTimeToSystemTime(arg1, arg2)
{
	return DllCall("FileTimeToSystemTime", "UInt", arg1, "UInt", arg2)
}

FileTimeToLocalFileTime(arg1, arg2)
{
	return DllCall("FileTimeToLocalFileTime", "UInt", arg1, "UInt", arg2)
}

TrimR2(str)
{
    StringRight, out, str, 2
    Loop
    {
        If(StrLen(out) < 2)
            out=0%out%
        Else
            Break
    }
    return out
}

SystemTimeToString(ByRef arg)
{
    year:=TrimR2(Get_ST_wYear(arg))
    month:=TrimR2(Get_ST_wMonth(arg))
    day:=TrimR2(Get_ST_wDay(arg))
    hour:=TrimR2(Get_ST_wHour(arg))
    minute:=TrimR2(Get_ST_wMinute(arg))
    second:=TrimR2(Get_ST_wSecond(arg))
    str=%year%/%month%/%day% %hour%:%minute%:%second%
    return str
}

AdjustFilename(arg)
{
	StringGetPos, pos, arg, ., R
	If ErrorLevel = 1
		return arg
	pos:=pos+1
	execpath:=AfxFindWindowExec()
	inipath:=RegExReplace(execpath, "i)\.exe$", ".ini")
	IniRead, len, %inipath%, CFG, LEN_EXT
	If(pos >= 15 or StrLen(arg) - pos > len)
		return arg
    target:=SubStr(arg, 1, pos - 1)
    replace=%target%
	Loop, % 15 - pos
	{
		replace:=replace . " "
	}
	ext:=SubStr(arg, pos + 1, StrLen(arg) - pos)
	result:=replace . "." . ext
	return result
}

#Include %A_ScriptDir%
#Include afxctrl.ahk

path=%1%
file=%2%

handle:=CreateFile(path . "\" . file, FILE_GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, 0, 0)
Init_BHFI(struct)
GetFileInformationByHandle(handle, &struct)
CloseHandle(handle)

Init_FT(ctime)
Init_FT(lctime)
Init_FT(atime)
Init_FT(latime)

links:=Get_BHFI_nNumberOfLinks(struct)
Get_BHFI_ftCreationTime(struct, ctime)
Get_BHFI_ftLastAccessTime(struct, atime)
FileTimeToLocalFileTime(&ctime, &lctime)
FileTimeToLocalFileTime(&atime, &latime)

Init_ST(sysctime)
FileTimeToSystemTime(&lctime, &sysctime)
strctime:=SystemTimeToString(sysctime)
Init_ST(sysatime)
FileTimeToSystemTime(&latime, &sysatime)
stratime:=SystemTimeToString(sysatime)

file:=AdjustFilename(file)
str=%file%`tlinks %links% ctime %strctime% atime %stratime%
AfxSetStatusBarText(2, " " . str)
